function [arF,x] = arFore(x,lags,fixWindInd,diffIndex);
%
% generates recursive out-of-sample AR(lags) forecasts of x
% fixWindInd   0 increasing window, non0 fixed window

if diffIndex; xTran=diff(x); else xTran=x; end;
xTran=makeCol(xTran); T=length(xTran); arF=repmat(nan,size(xTran));
startVal=20; window=startVal;
X1=mklagsmine(xTran,[1 lags]'); X=X1.xl; y=xTran(lags+1:end);
rollNumb=T-startVal-lags-1; rollF=repmat(nan,rollNumb,1); rollE=rollF; rollAct=rollF; const=rollF;
for i=1:rollNumb; 
    startObs=(fixWindInd==0)+(fixWindInd~=0)*i;
    [rollF(i),rollE(i),rollAct(i),const(i)]=rollFuncAR(startObs,startVal+i,X,y);    
end; 
arF(startVal+2+lags:startVal+rollNumb+lags+1)=rollF;
if fixWindInd; lab='Fixed'; else; lab='Increasing'; end;
fprintf(['MSE of Forecasts, ' lab ' Window:  %3.3f\n'],mean(rollE.^2)); 
if diffIndex; arF=[nan; arF+x(1:end-1)]; end;
arF(2:startVal+lags+2)=x(1:startVal+lags+1); 

%==========================================================================
function [rollF,rollE,rollAct,const]=rollFuncAR(regStart,regEnd,X,y);
yRoll=y(regStart:regEnd); rollAct=y(regEnd+1);
Xroll=X(regStart:regEnd,:); Xlast=X(regEnd+1,:); 
betaRoll(:,1)=pinv(Xroll'*Xroll)*Xroll'*yRoll; 
% Forecasts and Forecast Errors
rollF=Xlast*betaRoll;
rollE=rollF-rollAct;
if nargout>3; const=betaRoll(1); end;
   