function yPad=padAR2(y,yf,fcode,n,nar);
%     AFTER STOCK'S AND WATSON'S GAUSS PROCEDURE 2/12/03
% /* -- Pad Data series y out using AR Forecasts and Backcasts
%       y -- series to be padded
%      yf -- data to use in AR (levels or diffs)
%      fcode -- 1 if yf is first dif of y
%               otherwise yf=y
%      n -- number of terms to pad forward and backward
%      nar -- order of autoregression to use
% */
y=makeCol(y); yf=makeCol(yf);

%@ Pad out future @
yF=foreY(yf,n,nar);
if fcode == 1; yF=cumsum(yF) + ones(n,1)*y(end); end;
yPad=[y;yF];

%@ Pad out past, by reversing series @
yf=flipud(yf); if fcode==1; yf=-yf; end;
yB=foreY(yf,n,nar);
if fcode == 1; yB=cumsum(yB) + ones(n,1)*y(1); end;
yPad=[flipud(yB);yPad];

%======================================================================
function yF=foreY(y,n,nar);
w=y(nar+1:length(y));
x=ones(size(w));
for i=1:nar;
   x=[x y(nar+1-i:length(y)-i)];
end;
beta=pinv(x'*x)*(x'*w);
v=flipud(y(length(y)-nar+1:length(y)));
yF=zeros(n,1);
for i=1:n;
     yF(i)=beta'*[1;v];
     v(2:length(v))=v(1:length(v)-1);
     v(1)=yF(i);
end;
