function [irs,imp]=irs3(beta,allLags,persForward,shapeIndex);
%
% calculates the effect of 1% rise in unemployment on \Delta inflation
% shapeIndex: 1 normal 1% impulse, 2 slow (tent-shaped) impulse 
%
unRange=allLags(2,1)-allLags(1,1)+1;
inflRange=allLags(2,2)-allLags(1,2)+1;
switch shapeIndex
case 1;
   imp=[zeros(5,1);1; zeros(persForward,1)];
   irs=filter([0; beta(2:unRange+1)],[1; -beta(unRange+2:unRange+inflRange+1)],imp);
case 2;
   imp=[0;(0:.25:1)';(.75:-.25:0)'; zeros(persForward-4,1)]; imp=imp/sum(imp); % norm to 1
   irs=filter([0; beta(2:unRange+1)],[1; -beta(unRange+2:unRange+inflRange+1)],imp);   
otherwise
   irs=nan;
end;