function [AF,PF,AS,PS,mu,F]=getKlmNruRegP(theta,y,X,unLags);
%
% filtered and smoothed estimates of the state variable and its variance 

theta=makeCol(theta); nobs=length(y);
u=y-X*theta(1:end-2);

Z=-theta(2:unLags+1);
T=zeros(unLags); T(1)=1;
H=theta(end-1); Q=zeros(unLags); Q(1)=theta(end);
if unLags>1; T(2:end,1:end-1)=eye(unLags-1); end;

mu=repmat(nan,nobs,1); F=mu; atgtm1=repmat(nan,unLags,nobs); atgt=atgtm1; atgT=atgt;
ptgtm1=repmat(nan,[unLags,unLags,nobs]); ptgt=ptgtm1; ptgT=ptgt; J=ptgt;
for t = 1:nobs;
    % Prediction
    if t==1; atgtm1(:,t)=repmat(0,unLags,1); ptgtm1(:,:,t)=zeros(unLags); ptgtm1(1,1,1)=1e3; 
    else; atgtm1(:,t)=T*atgt(:,t-1); ptgtm1(:,:,t)=T*ptgt(:,:,t-1)*T'+Q; 
    end;
    % Updating
    mu(t) = u(t) - Z'*atgtm1(:,t);
    F(t) = Z'*ptgtm1(:,:,t)*Z+H;
    atgt(:,t) = atgtm1(:,t)+ptgtm1(:,:,t)*Z*pinv(F(t))*mu(t);
    ptgt(:,:,t) = ptgtm1(:,:,t)-ptgtm1(:,:,t)*Z*pinv(F(t))*Z'*ptgtm1(:,:,t);
end;

% Smoother
atgT(:,nobs)=atgt(:,nobs); ptgT(:,:,nobs)=ptgt(:,:,nobs);
for t= 1:nobs-1;
    J(:,:,nobs-t)=ptgt(:,:,nobs-t)*T'*pinv(ptgtm1(:,:,nobs-t+1));
    atgT(:,nobs-t) = atgt(:,nobs-t)+J(:,:,nobs-t)*(atgT(:,nobs-t+1)-atgtm1(:,nobs-t+1));
    ptgT(:,:,nobs-t) = ptgt(:,:,nobs-t)+J(:,:,nobs-t)*( ptgT(:,:,nobs-t+1)-ptgtm1(:,:,nobs-t+1) )*J(:,:,nobs-t)';
end;

AF=atgt(1,:)'+(theta(1)+theta(size(X,2))*X(:,end))/sum(Z);
PF=squeeze(ptgt(1,1,:));
AS=atgT(1,:)'+(theta(1)+theta(size(X,2))*X(:,end))/sum(Z);
PS=squeeze(ptgT(1,1,:));
%muT=u-atgT*Z;  
% nruP=-(betaOLSp(1)+Xprod(:,2:max(prodLags)+1)*betaOLSp(2:max(prodLags+1)))/sum(betaOLSp(max(prodLags)+2:max(prodLags)+1+max(unLags)));

