%
% prints out the interesting stuff in a Table
%      OLS   RW   Prod
%  sum unemployment
%  se sum unemployment
%  Pval unemployment
%  Pval inflation
%  Pval supply shocks
%  mean width of NAIRU CIs
%  sacrifice ratio
%  MUB se

% OLS
resTable=repmat(nan,10,3); 
if length(ftstat)>2;
    resTable(1)=unSum; resTable(2)=unSumSE;  resTable(3)=ftstat(1,2); resTable(4)=ftstat(2,2);  
else;
     resTable(1)=unSum; resTable(2)=unSumSE;  resTable(3)=2*(1-normcdf(abs(unSum./unSumSE)));
     resTable(4)=ftstat(1,2);     
end; 
if shoxIndex; resTable(5)=2*(1-normcdf(abs(betaOLS(end)./sqrt(vcvOLS(end))))); end;
resTable(8)= mean(diff(nairuCIar')');
resTable(9)=-1./(frequency*impRespOLSSlo(end));

% RW
resTable(1,2)=B1; resTable(2,2)=seB1; resTable(3,2)=1-chi2cdf(uZeroStatRW,maxUn); resTable(4,2)=1-chi2cdf(iZeroStatRW,maxInfl);
if shoxIndex; resTable(5,2)=2*(1-normcdf(abs(initEstimates(end-2)./vcvSErw(end-2)))); end;
resTable(8,2)= mean(diff1);
resTable(9,2)=sacrRat(1);
resTable(10,2)=allTau(2,2); 

% Prod
resTable(1,3)=B1p; resTable(2,3)=seB1p; resTable(3,3)=1-chi2cdf(uZeroStat,maxUn); resTable(4,3)=1-chi2cdf(iZeroStat,maxInfl);
if shoxIndex; resTable(5,3)=2*(1-normcdf(abs(mleEstimates2(2+maxUn+maxInfl)./vcvSE(2+maxUn+maxInfl)))); end;
resTable(6,3)=1-chi2cdf(pZerosStat,mpLags+1);
resTable(7,3)= mleEstimates2(maxUn+maxInfl+4+constIndex);
resTable(8,3)= mean(diff2);
resTable(9,3)=sacrRat(2);
resTable(10,3)=allTau(4,2);

resTable=myRound(resTable,4);