% dataFile(:,1) ... dates
prd=100*diff(log(dataFile(:,2:9))); 
un=dataFile(:,10:17);
cpi=dataFile(:,18:25); infl=100*diff(log(cpi)); dinfl=diff(infl);
time=(1959:2000)';
upF=15; hiF=10; dprd=diff(prd); dprd=[dprd(1,:); dprd];
[xbprd, junk] = bpassar(prd,2,upF,hiF,2,0,0,1,1,6.25e-8);
[xbdprd, junk] = bpassar(dprd,2,upF,hiF,2,0,0,1,1,6.25e-8);
[xbpun, junk] = bpassar(un,2,upF,hiF,2,0,0,1,1,6.25e-8);
prodTrend=prd-xbprd; unTrend=un-xbpun; dprodTrend=dprd-xbdprd;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure; plot(time,un); title('Unemployment'); legend(labs);
figure; plot(time(2:end),infl); title('Inflation'); legend(labs);
figure; plot(time(2:end),prodTrend); title('Productivity'); legend(labs); 
maxDiff=10;
f1=figure; f2=figure; crr=repmat(nan,size(un,2),1); crr22=repmat(nan,maxDiff,size(un,2));
for i=1:size(un,2); % figure; plot(time(2:end),[prodTrend(:,i) unTrend(2:end,i)]); title(['Productivity and Unemploynment -- ' fullLab(i,:)]); legend('Productivity','Unemployment'); 
    figure(f1); subplot(4,2,i); h=myPlot(time(2:end),[prodTrend(:,i) unTrend(2:end,i)]); ind=min(~isnan([prodTrend(:,i) unTrend(2:end,i) ]'))';
    crr2=corrcoef([prodTrend(ind,i) unTrend([logical(0); ind],i)]); crr(i)=crr2(2);
    ttt=title([ fullLab(i,:) '    correlation:  ' num2str(myRound(crr(i),2)) ]); 
    set(ttt,'fontsize',8); set(gca,'fontsize',7); set(h,'linewidth',1);
    axis([-inf inf 0 15]); %set(h,'linewidth',1); 
    if i==1; lll=legend('Productivity','Unemployment');  set(lll,'fontsize',7); end; disp(fullLab(i,:));
	yBp=unTrend([logical(0);ind],i); xBp=[ones(size(prodTrend(ind,i))) prodTrend(ind,i)]; bpHat=xBp\yBp; bpE=yBp-xBp*bpHat; 
    bpVcvOLS=var(bpE)*inv(xBp'*xBp); bpv=nwest_mine(yBp,xBp,4); bpVcv=bpv.V;
	rsq(1,1)=1-var(bpE)/var(yBp); rsq(2,1)=1-var(bpE)/var(yBp)*(size(xBp,1)-1)/(length(xBp)-2);
	[ftstat,ftname]=regprint(bpHat,strvcat('constant','prod'),[],bpVcv,bpE,1,length(yBp),rsq,1);   
    %kReg(yBp,dprodTrend(ind,i),k,1);
    for jj=1:maxDiff;
        crr22(jj,i)=kRegFilt(yBp,prd(ind,i),jj);
    end;
    figure(f2); subplot(4,2,i); h=myPlot(time(3:end),[(dprodTrend(2:end,i)) unTrend(3:end,i)]); u2=unTrend([logical(0); ind],i);
    crrD2=corrcoef([diff(prodTrend(ind,i)) u2(2:end)]); crrD(i)=crrD2(2);
    ttt=title([ fullLab(i,:) '    correlation:  ' num2str(myRound(crrD(i),2)) ]); 
    set(ttt,'fontsize',8); set(gca,'fontsize',7);
    % axis([-inf inf 0 15]); %set(h,'linewidth',1); 
    if i==1; lll=legend('Productivity','Unemployment'); set(lll,'fontsize',7); end; 
end;

% correlation CIs
nnn=length(xBp); zi=(log(1+crr)-log(1-crr))/2;
chi2corr=sum(zi.^2)-sum(zi.^2)/size(un,2)
crrN=crr(crr<0); ziN=(log(1+crrN)-log(1-crrN))/2;
chi2corrN=sum(ziN.^2)-sum(ziN.^2)/size(un,2)
zN=(ziN-mean(ziN))*sqrt(nnn-3)

% SUR
varIndex=[3 5 6]'; bYl=length(unTrend(2:end-2,1)); m=length(varIndex);
bigY=unTrend(2:end-2,varIndex); bigXprod=prodTrend(1:end-2,varIndex); nwEbyE=zeros(2*m,2*m); jj=1;
for i=1:m;
    depVar=bigY(:,i); indepVar=[ones(size(depVar)) bigXprod(:,i)];
    varMat=nwest_mine(depVar,indepVar,4); nwVcv=varMat.V;
    nwEbyE(jj:jj+1,jj:jj+1)=nwVcv;
    jj=jj+2;
end;

bigY=bigY(:);
bigXprod=repmat(bigXprod,m,1); multMat=kron(eye(m),ones(bYl,1)); bigXprod=bigXprod.*multMat;
bigX=repmat(nan,length(bigXprod),2*m); bigX(:,1:2:end)=multMat; bigX(:,2:2:end)=bigXprod;
betaFst=bigX\bigY; eFst=bigY-bigX*betaFst; eFst=reshape(eFst,bYl,m); vareFst=cov(eFst);
var2nd=kron(inv(vareFst),eye(bYl)); beta2nd=inv(bigX'*var2nd*bigX)*bigX'*var2nd*bigY;
e2nd=bigY-bigX*beta2nd; e2nd=reshape(e2nd,bYl,m);
Vmat=nwest_mineSUR(prodTrend(1:end-2,varIndex),e2nd,4);

R1=eye(2*(m-1)); R1=-R1(2:2:end,:); R=[zeros(m-1,1) ones(m-1,1) R1]; q=zeros(m-1,1);
chi2stat=(R*beta2nd-q)'*inv(R*nwEbyE*R')*(R*beta2nd-q)
chi2prob=1-chi2cdf(chi2stat,m-1)
fullLab(varIndex,:)
keyboard

